#ifndef LIST_H
#define LIST_H

typedef struct IntListNode {
	int num;
	struct IntListNode* next;
} IntListNode;

typedef struct IntList {
	IntListNode* first;
	IntListNode* last;
} IntList;

// Luo uuden kokonaislukulistan.
IntList* create_int_list();

// Tuhoaa kokonaislukulistan.
void delete_int_list(IntList* list);

// Lisää alkion listan loppuun.
void add_to_int_list(IntList* list, int num);

// Suorittaa parametrina annettavan funktion kullekin listan alkiolle.
void apply_to_int_list(IntList* list, void (*func)(int));

// Vertailee, ovatko listat samoja (sisältävät samat alkiot).
int equals_int_lists(const IntList* list1, const IntList* list2);

#endif
