#ifndef DP_FINDER_H
#define DP_FINDER_H

#include <stdlib.h>

/*
 * Ukkosen rajoitettu dynaaminen algoritmi likimääräiseen hahmon etsintään.
 * Params:
 *		text = Teksti, josta hahmoa etsitään.
 *		t_length = Tekstin pituus.
 *		pattern = Haettava hahmo.
 *		p_length = Hahmon pituus.
 *		max_errors = Suurin sallittu virheiden määrä hahmon esiintymässä.
 *		hit = Funktio, jota kutsutaan, kun löydetään esiintymä.
 */
void dp_find(const char* text, size_t t_length, const char* pattern, size_t p_length, size_t max_errors, void (*hit)(int));

#endif
